// SDDemos.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#pragma region Step 03
#include <Windows.h>
#include <wmistr.h> // Because of WNODE_HEADER
#pragma endregion
#pragma region Step 02
#include <Evntrace.h>
#pragma endregion 

#pragma region GUIDs etc
#include <guiddef.h>

// {D58E3528-B408-443a-8442-6FA144133466}
static const GUID MyTraceGUID = 
{ 0xd58e3528, 0xb408, 0x443a, { 0x84, 0x42, 0x6f, 0xa1, 0x44, 0x13, 0x34, 0x66 } };
// {416EE49F-64B7-4a61-AC35-7D97E3070E19}
static const GUID MyEventGUID = 
{ 0x416ee49f, 0x64b7, 0x4a61, { 0xac, 0x35, 0x7d, 0x97, 0xe3, 0x7, 0xe, 0x19 } };
#pragma endregion
#pragma region Event structure
typedef struct _myevent_01
{
  EVENT_TRACE_HEADER Header;
  MOF_FIELD Data[1];  
} MYEVENT_01, *PMYEVENT_01;
#pragma endregion
#pragma region Pre functions definition
ULONG WINAPI ControlCallback(
  __in                 WMIDPREQUESTCODE RequestCode,
  __in                 PVOID Context,
  __in                 ULONG* Reserved,
  __in                 PVOID Buffer
);
#pragma endregion
#pragma region Global Variables
BOOLEAN IAmEnabled = false;
TRACEHANDLE MyTraceHandle = NULL;
UCHAR MyTraceLevel = 0;
ULONG MyTraceFlags = 0;
#pragma endregion
ULONG WINAPI ControlCallback(WMIDPREQUESTCODE RequestCode,
							 PVOID Context, ULONG* Reserved, PVOID Buffer)
{
	PWNODE_HEADER Wnode;
	ULONG RC = ERROR_SUCCESS;
	printf("ControlCallback Entered\n");
	switch (RequestCode)
	{
		case WMI_ENABLE_EVENTS:
			printf("RequestCode is WMI_ENABLE_EVENTS\n");
			IAmEnabled = true;
			SetLastError(ERROR_SUCCESS);
			MyTraceHandle =GetTraceLoggerHandle(Buffer);
#pragma region Error cheking
			if (INVALID_HANDLE_VALUE == (HANDLE)MyTraceHandle)
			{
				RC = GetLastError();
				printf("GetTraceLoggerHandle failed with, %d.\n", RC);
				return RC ; // nobody checks it anyway
	        }
			SetLastError(ERROR_SUCCESS);
#pragma endregion
			MyTraceLevel = GetTraceEnableLevel(MyTraceHandle);
#pragma region Error cheking
			if (0 == MyTraceLevel)
			{
				RC = GetLastError();
				if (RC != ERROR_SUCCESS)
				{
					printf("GetTraceEnableLevel failed with, %d.\n", RC);
					return RC ; // nobody checks it anyway
				}
				MyTraceLevel = TRACE_LEVEL_WARNING; 
			}
			SetLastError(ERROR_SUCCESS);
#pragma endregion
			MyTraceFlags=GetTraceEnableLevel(MyTraceHandle);
#pragma region Error cheking
			if (0 == MyTraceFlags)
			{
				RC = GetLastError();
				if (RC != ERROR_SUCCESS)
				{
					printf("GetTraceEnableLevel failed with, %d.\n", RC);
					return RC ; // nobody checks it anyway
				}
				MyTraceFlags = 0; 
			}
#pragma endregion
			break;
		case WMI_DISABLE_EVENTS:
			printf("RequestCode is WMI_DISABLE_EVENTS\n");
			IAmEnabled = false;
			MyTraceHandle = NULL;
			MyTraceLevel = 0;
			MyTraceFlags = 0;
			break;
		default:
			printf("Un recognized RequestCode %d go to Wmistr.h to find what is it\n",RequestCode);
			return ERROR_INVALID_DATA ; // nobody checks it anyway
	}
#pragma region A lot of garbage printing
	printf("Your Context address is %x \n",Context);
	printf("Reserve address is %x  and value is %d\n",Reserved,*Reserved);
	Wnode = (PWNODE_HEADER) Buffer;
	printf("Wnode BufferSize is %d\n",Wnode->BufferSize);
	printf("Wnode ClientContext address is %x\n",Wnode->ClientContext);
	printf("Wnode CountLost is %d\n",Wnode->CountLost);
	printf("Wnode Flags is %x\n",Wnode->Flags);
	printf("Wnode HistoricalContext is %d\n",Wnode->HistoricalContext);
	printf("Wnode KernelHandle is %d\n",Wnode->KernelHandle);
	printf("Wnode Linkage is %d\n",Wnode->Linkage);
	printf("Wnode ProviderId is %d\n",Wnode->ProviderId);
	printf("Wnode TimeStamp is %d\n",Wnode->TimeStamp);
	printf("Wnode Version is %d\n",Wnode->Version);
#pragma endregion
	return ERROR_SUCCESS ; // nobody checks it anyway
}

int _tmain(int argc, _TCHAR* argv[])
{
#pragma region Local Variables
	MYEVENT_01 MyEvent;
	TRACEHANDLE MyRegistrationHandle;
	ULONG RC = ERROR_SUCCESS;
	TRACE_GUID_REGISTRATION Tgr[1];
	Tgr[0].Guid=&MyEventGUID;
	Tgr[0].RegHandle=NULL;
#pragma endregion
#pragma region Step A
	RC = RegisterTraceGuids(ControlCallback,NULL,&MyTraceGUID,1,Tgr,NULL,NULL,&MyRegistrationHandle);
#pragma endregion
#pragma region Check RC
	if (RC != ERROR_SUCCESS)
	{
		printf("RegisterTraceGuids failed with, %d.\n", RC);
		return RC;
	}
#pragma endregion
	printf("Press enter to send an event, CTL+Z to exit");
	while (EOF!=getchar())
	{
#pragma region If-ing the trace
		if (IAmEnabled) 
		{
#pragma region create and send trace
			ZeroMemory(&MyEvent,sizeof(MYEVENT_01));
			MyEvent.Header.Size=sizeof(MYEVENT_01);
			MyEvent.Header.Guid = MyEventGUID;
			MyEvent.Header.Class.Type = 20;
			MyEvent.Header.Class.Level = TRACE_LEVEL_WARNING;
			MyEvent.Header.Flags=WNODE_FLAG_TRACED_GUID | WNODE_FLAG_USE_MOF_PTR;
			MyEvent.Data[0].DataPtr = (ULONG64)  "Hello World!\n";
			MyEvent.Data[0].Length = 13;
			TraceEvent(MyTraceHandle,(PEVENT_TRACE_HEADER) &MyEvent);
#pragma endregion
		}
#pragma endregion
	}
#pragma region Step B
	UnregisterTraceGuids(MyRegistrationHandle);
#pragma endregion
	return 0;
}

